#!/usr/bin/python
# -*- coding: utf_8 -*-
from ConfigParser import NoOptionError, ParsingError, NoSectionError
from IniParser import IniParser
from configuraciones import *
import shutil
#True_False
booleanos = ('SOUND', 'LOCALDEV', 'NBD_SWAP', 'USE_LOCAL_SWAP', 'NETWORK_COMPRESSION')

#Multi
multiopcion = {'SOUND_DAEMON': ('esd' , 'nasd'),
'CONSOLE_KEYMAP': None,
'SCREEN_07': ('xdmcp', 'ldm', 'shell', 'telnet'),
'XSERVER': listaDriversXorg(),
'X_COLOR_DEPTH': ('16', '24', '32', '8'),
'X_MOUSE_PROTOCOL': ('sunkbd', 'lkkbd', 'vsxxxaa', 'spaceorb', 'spaceball', 'magellan', 'warrior', 'stinger', 'mousesystems', 'sunmouse', 'microsoft', 'mshack', 'mouseman', 'intellimouse', 'mmwheel', 'iforce', 'h3600ts', 'stowawaykbd', 'ps2serkbd', 'twiddler', 'twiddlerjoy'),
'X_MODE_0':('1152×864', '1024×768', '800×600', '640×480', '1600x900 ', '1280x800', '1280×720', '1024x600'),
'XKBLAYOUT':('es','us','latam')
}

#Arbitrario
arbitrario = ('X_HORZSYNC', 'X_VERTREFRESH', 'X_MOUSE_DEVICE')

	
class LtspParser(IniParser, object):
	"Carga en una estructura el archivo lts.conf"
	def __init__(self, path=LTS_CONF):
		#self.empty = True
		super(LtspParser, self).__init__()
		try:
			ltsConf = open(path, 'r')
			self.readfp(ltsConf)
		except IOError:
			ltsConf = open(path, 'w')
		ltsConf.close()
		#self.empty = False

	#def have_data(self):
	#	return not self.empty
	def save(self, path=LTS_CONF):
		ltspConf = open(path, 'w')
		self.write(ltspConf)
		ltspConf.close()
		return True
	def optionxform(self, option):
		return option
	def get(self, section, option):
		try:
			return super(LtspParser, self).get(section, option)
		except (NoOptionError, NoSectionError):
			pass
		return ''
	def set(self, section, option, value):
		try:
			super(LtspParser, self).set(section, option, value)
		except NoSectionError:
			self.add_section(section)
			super(LtspParser, self).set(section, option, value)
		

class LtsConfGlobal:
	"Crea un parser, carga los check box de la configuración de lts.conf"
	def __init__(self, gladeUI, parser, updateWidget):
		self.parser = parser
		self.ssh = gladeUI.get_widget('ssh')
		self.xdmcp = gladeUI.get_widget('xdmcp')
		self.sonido = gladeUI.get_widget('sonido')
		self.extraibles = gladeUI.get_widget('extraibles')
		self.compresion = gladeUI.get_widget('compresion')
		# Cargar datos
		self.xdmcp.set_active(self.parser.get('Default', 'SCREEN_07') == 'xdmcp')
		ldm = self.parser.get('Default', 'SCREEN_07') == 'ldm'
		self.ssh.set_active(ldm)
		if ldm:
			self.compresion.set_active(self.parser.getboolean('Default', 'NETWORK_COMPRESSION'))
			self.sonido.set_active(self.parser.getboolean('Default', 'SOUND'))
			self.extraibles.set_active(self.parser.getboolean('Default', 'LOCALDEV'))
		self.extraibles.connect('toggled', self.on_extraibles_toggled)
		updateWidget(self.xdmcp)

	def on_extraibles_toggled(self, toggle, data=None):
		if not toggle.get_active():
			return
		dialog = gtk.MessageDialog(type=gtk.MESSAGE_QUESTION, buttons=gtk.BUTTONS_YES_NO, message_format='Para que un usuario pueda utilizar dispositivos de almacenamiento locales como pendrives y CDs debe pertenecer al grupo fuse.\nSi lo desea puede agregar usuarios al grupo fuse en este momento o hacerlo más tarde.\n¿Desea agregar usuarios al grupo fuse ahora?')
		dialog.set_title('Acceso a dispositivos locales')
		response = dialog.run()
		dialog.destroy()
		if response == gtk.RESPONSE_YES:
			process = subprocess.Popen('/usr/bin/users-admin')
			while process.poll() == None:
				while gtk.events_pending():
					gtk.main_iteration()

	def retrieve(self):
		self.parser.set('Default', 'SCREEN_07', 'ldm' if self.ssh.get_active() else 'xdmcp')
		self.parser.set('Default', 'NETWORK_COMPRESSION', self.compresion.get_active())
		self.parser.set('Default', 'SOUND', self.sonido.get_active())
		self.parser.set('Default', 'LOCALDEV', self.extraibles.get_active())
	def save(self):
		self.retrieve()
		self.parser.save()
		return True
